;********************** Beginn Befehle **************************

; NSH schaltet alle gewhlten Elemente aus (Noshow)

(defun C:NSH ( / a)

(princ "\nZum Ausschalten")
(setq a (ssget))                      ; sichtbare whlen
(if a
  (noshow a)                          ; ausschalten
  (princ "\nKeine Elemente gewhlt\n")
)
(princ)
)

; SSH schaltet die gewhlten Elemente wieder ein (Switch to show)
; Achtung: nach (grclear) knnen auch Elemente gefunden werden, die momentan unsichtbar sind,
; sich aber trotzdem schon im eingeschalteten Zustand befinden. Durch diese Auswahl
; wird aber ihr Zustand nicht verndert!

(defun C:SSH ( / a b)
(setq
  a (ssget "X" (list (cons 60 1)))    ; Alle ausgeschalteteten aus der Datenbank holen
)
(if a
  (progn
  (grclear)                ; alle sichtbaren lschen
  (show a)                ; alle unsichtbaren zeigen
  (princ "\nZur Sichtbarkeit")
  (setq b (ssget))        ; gewnschte whlen
    (if b                  ; falls welche gewhlt
    (progn
      (noshow (sssub a b))  ; von den bisher unsichtbaren die gewhlten herausnehmen
      (show b )            ; und die gewhlten wieder sichtbar machen
    )
    (noshow a)            ; wenn keine gewhlt, wieder alle Unsichtbaren zurck
    )
  )
  (princ "\nKeine Elemente unsichtbar geschaltet\n")
)
(redraw)                    ; Bildschirm wieder herstellen
(princ)
)

; TNSH schaltet alle unsichtbaren Elemente wieder sichtbat (toggle all noshow entities to show)

(defun C:TNSH ( / a)

(setq
  a (ssget "X" (list (cons 60 1)))    ; alle unsichtbaren in der Datenbank suchen
)
(if a                                ; falls welche gefunden
  (show a)                            ; diese anzeigen
  (princ "\nKeine Elemente unsichtbar geschaltet\n")
)
(princ)
)

;********************** Ende Befehle **************************

;**********************Beginn Funktionen  ****************************

; sssub subtrahiert von Auswahlsatz  a Entities die in Auswahlsatz b enthalten sind

(defun sssub (a b / c d e)
(setq  d 0.0)              ; Realzahl als Indexzeiger fr Auswahlsatz verwenden
(while (setq e (ssname b d))
(if (ssmemb e a)
  (setq a (ssdel e a))
)
(setq d (1+ d))
)
a
)


; noshow schaltet die Entities in Auswahlsatz a unsichtbar

(defun noshow ( a / b c d e)
(setq
  b (sslength a)
  c 0.0
)
(while (setq d (ssname a c))
  (setq
  e (entget d)

;  Hier mu zum ersten Mal auf die Reihenfolge der Unterlisten in der Elementliste geachtet werden:
;  e (append (list (cons 60 1)) e) wrde mit R13 Entities nicht funktionieren !

  e (append e (list (cons 60 1)))
  )
  (entmod e)
  (setq c (1+ c))
)                    ; Ende while
)


; show schaltet die Entities in Auswahlsatz a sichtbar

(defun show ( a / b c d e)
(setq
  b (sslength a)
  c 0.0
)
(while (setq d (ssname a c))
  (setq
  e (entget d)
  e (subst (cons 60 0) (assoc 60 e) e ) ; Hier gilt fr die Reihenfolge das Gleiche wie bei noshow
  )
  (entmod e)
  (setq c (1+ c))
)                    ; Ende while
)


; fld gibt die zu a assozierte Unterliste aus Liste b zurck

(defun fld (a b)
(cdr(assoc a b))
)

;**********************Ende Funktionen  ****************************